import { Vnode, ViewResult } from './Widget';
import { Widget } from './Widget';
import { WidgetAttrs } from './Widget';
import { State, Stateful, StateTransition } from "./State";
export interface ClickResponse {
    (s: number): number;
}
export declare const ClickResponses: {
    advance: ClickResponse;
    on: ClickResponse;
};
export interface ButtonAttrs extends WidgetAttrs {
    onclick: (newStateIndex?: number, newState?: string) => void;
}
export declare class Button extends Widget {
    pressed: boolean;
    pressing: (down: boolean) => void;
    oninit(node: Vnode<ButtonAttrs, this>): void;
    view(node: Vnode<ButtonAttrs, this>): ViewResult;
}
export interface ToggleButtonAttrs extends ButtonAttrs {
    initial?: number;
    stateAccess?: (stateful: Stateful) => void;
    stateTransition?: StateTransition;
}
export declare class ToggleButton extends Button {
    state: State;
    numStates: number;
    oninit(node: Vnode<ToggleButtonAttrs, this>): void;
    view(node: Vnode<ToggleButtonAttrs, this>): ViewResult;
}
export interface OnOffButtonAttrs extends ToggleButtonAttrs {
}
export declare class OnOffButton extends ToggleButton {
    static states: string[];
    oninit(node: Vnode<OnOffButtonAttrs, this>): void;
    view(node: Vnode<OnOffButtonAttrs, this>): ViewResult;
}
export interface IconButtonAttrs extends OnOffButtonAttrs {
    mdi?: string;
}
export declare class IconButton extends ToggleButton {
    oninit(node: Vnode<IconButtonAttrs, this>): void;
    view(node: Vnode<IconButtonAttrs, this>): ViewResult;
}
