import { Vnode } from './Widget';
import { ViewResult } from './Widget';
import { WidgetAttrs } from './Widget';
import { Widget } from './Widget';
import { Stateful, StateTransition } from "./State";
export interface OptionButtonsAttrs extends WidgetAttrs {
    onclick: (buttonIndex: number, newState: number, states: number[]) => void;
    initial?: number[];
    buttonTransition?: StateTransition;
    buttonConstraint?: (buttonIndex: number, newState: number, states: number[]) => number[];
}
interface ButtonConstraint {
    (buttonIndex: number, newState: number, states: number[]): number[];
}
interface ButtonConstraints {
    none: ButtonConstraint;
    radio: ButtonConstraint;
    [name: string]: ButtonConstraint;
}
export declare class OptionButtons extends Widget {
    static constraints: ButtonConstraints;
    stateAccess: Stateful[];
    setAccessFn: (stateful: Stateful, buttonIndex: number) => void;
    oninit(node: Vnode<OptionButtonsAttrs, this>): void;
    view(node: Vnode<OptionButtonsAttrs, this>): ViewResult;
}
export interface RadioButtonsAttrs extends WidgetAttrs {
    onclick: (buttonIndex: number, newState: number, states: number[]) => void;
    initial?: number;
}
export declare class RadioButtons extends Widget {
    view(node: Vnode<RadioButtonsAttrs, this>): ViewResult;
}
export interface IconbuttonsAttrs extends WidgetAttrs {
    onclick: (buttonIndex: number, newState: number, states: number[]) => void;
    radioMode: boolean;
}
export declare class IconButtons extends Widget {
    view(node: Vnode<IconbuttonsAttrs, this>): ViewResult;
}
export {};
