export interface StateSetter {
    (newState: number): number;
}
export interface Stateful {
    getNumStates: () => number;
    getState: () => number;
    setState: (newState: number) => number;
}
export interface StateTransition {
    (state: Stateful, input?: any): number;
}
interface Transitions {
    cycle: StateTransition;
    onoff: StateTransition;
}
export declare class State implements Stateful {
    protected numStates: number;
    protected transition: StateTransition;
    static transitions: Transitions;
    protected state: number;
    constructor(numStates: number, initialState?: number, transition?: StateTransition);
    getNumStates: () => number;
    getState: () => number;
    setState: (newState: number) => number;
    advance: (input?: any) => number;
}
export {};
